import { statSync } from "node:fs";
import { dirname, join } from "node:path";
function tryStatSync(file) {
    try {
        return statSync(file, { throwIfNoEntry: false });
    }
    catch { }
}
export function findFile(directory, fileName) {
    while (directory) {
        const fullPath = join(directory, fileName);
        if (tryStatSync(fullPath)?.isFile())
            return fullPath;
        const parentDirectory = dirname(directory);
        if (parentDirectory === directory)
            return;
        directory = parentDirectory;
    }
}
//# sourceMappingURL=findFile.js.map